C A simple program to calculate the frequency of the date of Easter for a given period of time (year1 to year2)
C The frequency values are written to the file easterfq.txt
C Uses the program EASTER from "Interactive Fortran 77 - A Hands on Approach" as subroutine

      PROGRAM EASTER3

      INTEGER YEAR, YEAR1, YEAR2, MONTH, LUNA, I, J
      CHARACTER*5 SMONTH
      INTEGER FREQ(61), FREQX(61)
      REAL FRQ

      DO I = 1, 61
        FREQ(I) = 0
      ENDDO
      WRITE (*, *) 'Calculate frequency of Easter for a given period:'
      WRITE (*, "(A14, $)") ' First year = '
      READ *, YEAR1
      WRITE (*, "(A14, $)") ' Last year  = '
      READ *, YEAR2
      IF (YEAR2.GE.YEAR1) THEN
        OPEN(UNIT=1, FILE='easterfq.txt')
        WRITE (1, "(A19, 1X, I4, 1X, A2, 1X, I4)")
     +    'Frequency of Easter for a period from ', YEAR1, 'to', YEAR2
        WRITE (1, *)
        DO YEAR = YEAR1, YEAR2
          CALL EASTER(YEAR, MONTH, LUNA)
          IF (MONTH.EQ.3) THEN
            FREQ(LUNA) = FREQ(LUNA) + 1
          ELSE
            FREQ(LUNA + 31) = FREQ(LUNA + 31) + 1
          ENDIF
        ENDDO
        DO I = 1, 61
          FREQX(I) = I
        ENDDO
        CALL FREQSORT (61, FREQ, FREQX)
        DO K = 1, 61
          IF (FREQ(K).EQ.0) EXIT        
          I = FREQX(K)
          IF (I.LE.31) THEN
            SMONTH = 'March'
            J = I
          ELSE
            SMONTH = 'April'
            J = I - 31
          ENDIF
          FRQ = 100 * (REAL(FREQ(K)) / REAL((YEAR2 - YEAR1 + 1)))
          WRITE (1, "(A5, 1X, I2, 5X, F5.2, A1)") SMONTH, J, FRQ, '%'
        ENDDO
        CLOSE(UNIT=1)
        WRITE (*, *) 'Easter frequency values in file: easterfr.txt'
      ENDIF

      END

C *************************************************
C * Subroutine to calculate Easter for a given year
C *************************************************

      SUBROUTINE EASTER(YEAR, MONTH, LUNA)

      INTEGER YEAR, METCYC, CENTRY, ERROR1, ERROR2, DAY, MONTH
      INTEGER EPACT, LUNA

C CALCULATING THE YEAR IN THE 19 YEAR METONIC CYCLE-METCYC
      METCYC = MOD(YEAR, 19) + 1
      IF (YEAR.LE.1582) THEN
        DAY = (5 * YEAR) / 4
        EPACT = MOD(11 * METCYC - 4, 30) + 1
      ELSE
C CALCULATING THE CENTURY-CENTRY
        CENTRY = (YEAR / 100) + 1
C ACCOUNTING FOR ARITHMETIC INACCURACIES
C IGNORES LEAP YEARS ETC.
        ERROR1 = (3 * CENTRY / 4) - 12
        ERROR2 = ((8 * CENTRY + 5) / 25) - 5
C LOCATING SUNDAY
        DAY = (5 * YEAR / 4) - ERROR1 - 10
C LOCATING THE EPACT (FULL MOON)
        EPACT = MOD(11 * METCYC + 20 + ERROR2 - ERROR1, 30)
        IF (EPACT.LT.0) EPACT = 30 + EPACT
        IF ((EPACT.EQ.25.AND.METCYC.GT.11).OR.EPACT.EQ.24) THEN
          EPACT = EPACT + 1
        ENDIF
      ENDIF
C FINDING THE FULL MOON
      LUNA = 44 - EPACT
      IF(LUNA.LT.21) LUNA = LUNA + 30
C LOCATING EASTER SUNDAY
      LUNA = LUNA + 7 -(MOD(DAY + LUNA, 7))
C LOCATING THE CORRECT MONTH
      IF (LUNA.GT.31) THEN
        LUNA = LUNA - 31
        MONTH = 4
      ELSE
        MONTH = 3
      ENDIF

      END

C ***********************************************
C * Subroutine to sort the Easter frequency array
C ***********************************************

      SUBROUTINE FREQSORT(N, ARRAY, INDEXES)

      INTEGER N, ARRAY(N), INDEXES(N)
      INTEGER F, X, I, J

      DO I = 1, N - 1
        DO J = I + 1, N
          IF (ARRAY(I).LT.Array(J)) THEN
            F = ARRAY(I)
            ARRAY(I) = ARRAY(J)
            ARRAY(J) = F
            X = INDEXES(I)
            INDEXES(I) = INDEXES(J)
            INDEXES(J) = X
          ENDIF
        ENDDO
      ENDDO
      DO I = 1, N - 1
        DO J = I + 1, N
          IF (ARRAY(I).EQ.Array(J).AND.INDEXES(I).GT.INDEXES(J)) THEN
            F = ARRAY(I)
            ARRAY(I) = ARRAY(J)
            ARRAY(J) = F
            X = INDEXES(I)
            INDEXES(I) = INDEXES(J)
            INDEXES(J) = X
          ENDIF
        ENDDO
      ENDDO      

      END
